package org.apache.bcel.classfile;

import java.io.IOException;
import java.io.DataInput;

public final class ConstantInvokeDynamic extends ConstantCP
{
    public ConstantInvokeDynamic(final ConstantInvokeDynamic c) {
        this(c.getBootstrapMethodAttrIndex(), c.getNameAndTypeIndex());
    }
    
    ConstantInvokeDynamic(final DataInput file) throws IOException {
        this(file.readShort(), file.readShort());
    }
    
    public ConstantInvokeDynamic(final int bootstrapMethodAttrIndex, final int nameAndTypeIndex) {
        super((byte)18, bootstrapMethodAttrIndex, nameAndTypeIndex);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitConstantInvokeDynamic(this);
    }
    
    public int getBootstrapMethodAttrIndex() {
        return super.getClassIndex();
    }
    
    @Override
    public String toString() {
        return super.toString().replace("class_index", "bootstrap_method_attr_index");
    }
}
